"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _Jinter_ast;
Object.defineProperty(exports, "__esModule", { value: true });
const visitor_1 = __importDefault(require("./visitor"));
const acorn_1 = require("acorn");
class Jinter {
    constructor(input) {
        _Jinter_ast.set(this, void 0);
        const program = (0, acorn_1.parse)(input, { ecmaVersion: 2020 });
        __classPrivateFieldSet(this, _Jinter_ast, program.body, "f");
        this.visitor = new visitor_1.default(__classPrivateFieldGet(this, _Jinter_ast, "f"));
        this.scope = this.visitor.scope;
        this.scope.set('print', (args) => console.log(...args));
        this.visitor.on('console', (node, visitor) => {
            if (node.type === 'Identifier')
                return console;
            if (node.type === 'CallExpression' && node.callee.type === 'MemberExpression') {
                const prop = visitor.visitNode(node.callee.property);
                const args = node.arguments.map((arg) => visitor.visitNode(arg));
                const console_prop = console[prop];
                if (!console_prop)
                    return 'proceed';
                return console_prop(...args);
            }
            return 'proceed';
        });
        this.visitor.on('Math', (node, visitor) => {
            if (node.type === 'Identifier')
                return Math;
            if (node.type === 'CallExpression' && node.callee.type === 'MemberExpression') {
                const prop = visitor.visitNode(node.callee.property);
                const args = node.arguments.map((arg) => visitor.visitNode(arg));
                const math_prop = Math[prop];
                if (!math_prop)
                    return 'proceed';
                return math_prop(...args);
            }
            return 'proceed';
        });
        this.visitor.on('String', (node, visitor) => {
            if (node.type === 'Identifier')
                return String;
            if (node.type === 'CallExpression' && node.callee.type === 'MemberExpression') {
                const prop = visitor.visitNode(node.callee.property);
                const args = node.arguments.map((arg) => visitor.visitNode(arg));
                const string_prop = String[prop];
                if (!string_prop)
                    return 'proceed';
                return string_prop(args);
            }
            return 'proceed';
        });
        this.visitor.on('Date', (node) => {
            if (node.type === 'Identifier')
                return Date;
        });
    }
    interpret() {
        return this.visitor.run();
    }
}
exports.default = Jinter;
_Jinter_ast = new WeakMap();
