"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
class FunctionDeclaration {
    static visit(node, visitor) {
        const { params, body } = node;
        const id = visitor.visitNode(node.id);
        // @TODO: Handle other types of params and pass them directly to next node instead of saving them in the global scope
        const fn = (0, utils_1.namedFunction)(id, (args) => {
            let index = 0;
            for (const param of params) {
                visitor.visitNode(param);
                if (param.type === 'Identifier') {
                    visitor.scope.set(param.name, args[index]);
                }
                else {
                    console.warn('Unhandled param type', param.type);
                }
                index++;
            }
            return visitor.visitNode(body);
        });
        visitor.scope.set(id, fn);
    }
}
exports.default = FunctionDeclaration;
