"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const utils_1 = require("../utils");
class FunctionExpression {
    static visit(node, visitor) {
        const { params, body } = node;
        const fn = (0, utils_1.namedFunction)('anonymous function', (args) => {
            let index = 0;
            for (const param of params) {
                visitor.visitNode(param);
                if (param.type === 'Identifier') {
                    visitor.scope.set(param.name, args[index]);
                }
                else {
                    console.warn('Unhandled param type', param.type);
                }
                index++;
            }
            return visitor.visitNode(body);
        });
        return fn;
    }
}
exports.default = FunctionExpression;
