"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class MemberExpression {
    static visit(node, visitor) {
        const { object, property, computed } = node;
        const obj = visitor.visitNode(object);
        const prop = computed ? visitor.visitNode(property) : visitor.getName(property);
        if (prop !== undefined || prop !== null) {
            if (visitor.listeners[prop]) {
                const cb = visitor.listeners[prop](node, visitor);
                if (cb !== 'proceed') {
                    return cb;
                }
            }
            return obj === null || obj === void 0 ? void 0 : obj[prop];
        }
    }
}
exports.default = MemberExpression;
