"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class ObjectExpression {
    static visit(node, visitor) {
        let result = {};
        for (const prop of node.properties) {
            if (prop.type === 'Property') {
                result = Object.assign(Object.assign({}, result), visitor.visitNode(prop));
            }
            else {
                throw new Error(`Unhandled property type: ${prop.type}`);
            }
        }
        return result;
    }
}
exports.default = ObjectExpression;
