"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class Property {
    static init(node, visitor) {
        const key = node.computed ? visitor.visitNode(node.key) : visitor.getName(node.key);
        const value = visitor.visitNode(node.value);
        if (key) {
            return { [key]: value };
        }
    }
    static get(_node, _visitor) {
        throw new TypeError('Not implemented: Property.get');
    }
    static set(_node, _visitor) {
        throw new TypeError('Not implemented: Property.set');
    }
    static visit(node, visitor) {
        switch (node.kind) {
            case 'init':
                return this.init(node, visitor);
            case 'get':
                return this.get(node, visitor);
            case 'set':
                return this.set(node, visitor);
            default:
                throw new Error(`Unhandled property kind: ${node.kind}`);
        }
    }
}
exports.default = Property;
